//+------------------------------------------------------------------+
//|                                                    Load_Hist.mq4 |
//|                                       Copyright 2015, Galladion  |
//|                                         https://vk.com/id1398982 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Galladion"
#property link      "https://vk.com/id1398982"
#property version   "1.00"
string Global_UPG="UPG";            //.       

extern string FileName="Symbols";   //       
extern int Pause=500;               //    
extern int j=10;                    //    
extern bool load_hist= false;       //   
extern bool art_line = false;       //   (  )

#import "user32.dll"
int PostMessageA(int hWnd,int Msg,int wParam,int lParam);
int SendMessageA(int hWnd,int Msg,int wParam,int lParam);
int GetParent(int hWnd);
int GetDlgItem(int hDlg,int nIDDlgItem);
#import

#define VK_HOME 0x24
#define VK_DOWN 0x28
#define WM_CLOSE 0x0010
#define WM_COMMAND 0x0111
#define WM_KEYDOWN 0x0100
#define LVM_GETITEMCOUNT 0x1004
#define VAR_HANDLE "Symbol_Handle"
//     
int Parent()
  {
   int hwnd=WindowHandle(Symbol(),Period());
   int hwnd_parent=0;

   while(!IsStopped())
     {
      hwnd=GetParent(hwnd);

      if(hwnd==0)
         break;

      hwnd_parent=hwnd;
     }

   return(hwnd_parent);
  }
//      "Market Watch"
int SymbolCount()
  {
   int hwnd=Parent();
   int Count=0;

   if(hwnd!=0) //   
     {
      hwnd=GetDlgItem(hwnd,0xE81C); //   
      hwnd = GetDlgItem(hwnd, 0x50);
      hwnd = GetDlgItem(hwnd, 0x8A71);

      Count=SendMessageA(hwnd,LVM_GETITEMCOUNT,0,0); //    
     }

   return(Count);
  }
//    ,     Num  "Market Watch"
void OpenChart(int Num)
  {
   int hwnd= Parent();
   if(hwnd!=0) //   
     {
      hwnd=GetDlgItem(hwnd,0xE81C); //  "Market Watch"
      hwnd = GetDlgItem(hwnd, 0x50);
      hwnd = GetDlgItem(hwnd, 0x8A71);

      PostMessageA(hwnd,WM_KEYDOWN,VK_HOME,0); //    "Market Watch"

      while(Num>1)
        {
         PostMessageA(hwnd,WM_KEYDOWN,VK_DOWN,0); //    
         Num--;
        }
     }

   PostMessageA(Parent(),WM_COMMAND,33160,0); //  

   return;
  }
//   
void CloseChart(int hwnd)
  {
   PostMessageA(GetParent(hwnd),WM_CLOSE,0,0);

   return;
  }
//     "Navigator"  
void RunScript()
  {
   PostMessageA(Parent(),WM_COMMAND,33042,0); //     

   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpgScript()
  {
   int B=Bars,h=1;
   PostMessageA(WindowHandle(Symbol(),Period()),WM_KEYDOWN,VK_HOME,0); //   "HOME"    
   while(true) //     ....
     {
      PostMessageA(WindowHandle(Symbol(),Period()),WM_KEYDOWN,VK_HOME,0); //   "HOME"    
      Sleep(3*Pause);
      RefreshRates();
      if(B==Bars) // ...     . "HOME"
        {
         if(h<=5) {Sleep(h*Pause);h++;continue;} // (   -  .   )
         GlobalVariableSet(Global_UPG,0);  //       -  . 
         return; // 
        }
      B=Bars;h=1;
     }
  }
//       
void WriteSymbol(string per)
  {
   int handle;
   string Str;
   double price=0;
   int k=0; //    "" -  
   string direction; //   
   for(int m=Bars-1;m>=0;m--) //      
     {
      price+=High[m]-Low[m];
     }
   price/=Bars-1;
   for(int l=Bars-1;l>=0;l--) //    . * .    
     {
      if(High[l]-Low[l]>j*price)
        {
         if(Open[l]<Close[l])direction = "UP";
         if(Open[l]>Close[l])direction = "DOWN";
         if(Open[l]==Close[l])direction="0";
         Str=Str+"\n"+per+";"+Symbol()+";"+TimeToStr(Time[l],TIME_DATE|TIME_MINUTES)+";"+DoubleToStr(price,MarketInfo(Symbol(),MODE_DIGITS))+";"+IntegerToString(j,0)+";"+DoubleToStr(round(j*price/Point),0)+";"+direction+";"+DoubleToStr(round((High[l]-Low[l])/Point)*MarketInfo(Symbol(),MODE_TICKVALUE),2)+";";
         while(art_line) //       
           {
            ObjectCreate(ChartID(),(string)k,OBJ_ARROW_CHECK,0,Time[l]+Time[0]-Time[1],High[l]);
            //---   
            ObjectSetInteger(ChartID(),(string)k,OBJPROP_ANCHOR,ANCHOR_BOTTOM);
            //---   
            ObjectSetInteger(ChartID(),(string)k,OBJPROP_WIDTH,3);
            break;
           }
         k++;
        }
     }

   handle=FileOpen(FileName,FILE_READ|FILE_WRITE|FILE_CSV,';');
   FileSeek(handle,-2,SEEK_END);

   FileWrite(handle,Str);
   FileClose(handle);
   return;
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   string interval;
   switch(Period()) //        
     {              //     default
      case 1: interval = "PERIOD_M1";break;
      case 5: interval = "PERIOD_M5";break;
      case 15: interval = "PERIOD_M15";break;
      case 30: interval = "PERIOD_M30";break;
      case 60: interval = "PERIOD_H1";break;
      case 240: interval= "PERIOD_H4";break;
      case 1440: interval="PERIOD_D1";break;
      case 10080: interval = "PERIOD_W1";break;
      case 43200: interval = "PERIOD_MN";break;
      default : return;
     }
   FileName+="_"+interval+".csv";
   int handle,Count,i=1;
   handle=FileOpen(FileName,FILE_READ|FILE_WRITE|FILE_CSV,';');
   FileWrite(handle,";;;.;.;..;.;- H/L;");
   FileClose(handle);
//---
   if(GlobalVariableCheck(VAR_HANDLE)) //    ...
     {
      GlobalVariableSet(VAR_HANDLE,WindowHandle(Symbol(),Period()));
      if(load_hist)UpgScript();
      WriteSymbol(interval);
     }
   else  //   
     {
      GlobalVariableSet(VAR_HANDLE,WindowHandle(Symbol(),Period()));

      handle=FileOpen(FileName,FILE_WRITE|FILE_CSV,';'); //    
      FileClose(handle);

      Count=SymbolCount();

      while(!IsStopped())
        {
         if(i>Count)
            break;

         OpenChart(i); //       "Market Watch"
         Sleep(Pause);

         if(GlobalVariableCheck(Global_UPG))GlobalVariableSet(Global_UPG,1);  //    

         RunScript(); //        
         Sleep(Pause);

         while(load_hist) //      
           {
            if(GlobalVariableCheck(Global_UPG)==true && (GlobalVariableGet(Global_UPG)==0)) break;  //     
           }
         while(!art_line) //   ,    
           {
            CloseChart(GlobalVariableGet(VAR_HANDLE)); //   
            Sleep(Pause);
            break;
           }
         i++;
        }

      GlobalVariableDel(VAR_HANDLE);
      GlobalVariableDel(Global_UPG);

      //        "Market Watch"
      handle=FileOpen(FileName,FILE_READ|FILE_WRITE|FILE_CSV,';');
      FileSeek(handle,0,SEEK_END);

      FileWrite(handle,"\nAMOUNT OF SYMBOLS = "+Count);
      FileClose(handle);
     }
   return;
  }
//+------------------------------------------------------------------+
